Basket = {
    _totalDiscount: 0,
    _basket: {},

    addToBasket: function()
    {
    	if($('.color .coloritem:checked').length == 0){
    	   Message.show('  ', '   ', 3);
    	   return;
    	}
    	if($('.clsize .sizeitem.activesize').length == 0){
    	   Message.show('  ', '   ', 3);
    	   return;
    	}
    	var cnt      = parseInt($('select.cnt').val());
    	var size     = $('.clsize .sizeitem.activesize:first').text();
    	var color    = $('.color .coloritem:checked:first').attr('color');
    	var uid     = $('input[name=id]').val();
    	var scnt     = 0;
		Basket._basket[uid + '^' + color + '^' + size] = cnt;
    	Basket.calculate();
        $.jsHttpRequest({
             url: '/catalog/tobasket/',
             data: {'order': Basket._basket},
             onReady: function(result, text) {
                if(text){
                    // console.log(text);
                    if(confirm('   .        ?')){
                    	window.location.reload();
                    	return;
                    }
                }
		    	$( "<div id='message' style='text-align: center;padding-top: 20px; '><a href='#'>&nbsp;</a><h1> </h1><a href='/customer/basket/' class='dashed-a'>  </a></div>" ).dialog({
		            title: '',
		            width: 300,
		            height: 170,
		            show: 'fade',
					modal: true
				});
				setTimeout(function(){ $('#message').dialog('destroy');  $('#message').remove(); }, 10000);		    	
             }
         });       	
    },
    
    reloadPage: function()
    {
    	window.location.reload();
    	$('#loader').show();
    },
    
    calculate: function()
    {
        var scnt = 0;
    	$.each(Basket._basket, function(k, v){
    	    scnt += parseInt(v);
    	});
    	$('.basket span').text(parseInt(scnt))
    },
    
    getCurrentDiscountValue: function(callback)
    {
        $.jsHttpRequest({
            url: '/customer/get-current-discount-value/',
            data: {},
            onReady: function(result, text) {
            	Basket._totalDiscount = parseFloat(text.replace(/,/, '.'));
            	callback();
            }
        });          	
    },
    
    
    deleteFromBasket: function(elem)
    {
        $.jsHttpRequest({
             url: '/catalog/deletefrombasket/',
             data: {'uid': $(elem).attr('uid')},
             onReady: function(result, text) {
                if(text){
                    if(confirm('   .        ?')){
                    	window.location.reload();
                    	return;
                    }
                }
                Basket._basket[$(elem).attr('uid')] = 0;
		    	$(elem).remove();
		    	Basket.reloadPage();
             }
         });       	
    },
    
    getCurrentOrderSum: function()
    {
    	return parseFloat($('.total .cost span').text());
    },
    
    changeOrderCnt: function(elem)
    {
        var uid = $(elem).parent().parent().attr('uid');
        $.jsHttpRequest({
             url: '/catalog/changecountbasket/',
             data: {'uid': uid, 'cnt': $(elem).val()},
             onReady: function(result, text) {
                if(text){
                    //console.log(text);
                    if(confirm('   .        ?')){
                    	Basket.reloadPage();
                    	return;
                    }
                }
                Basket._basket[uid] = $(elem).val();
                Basket.reloadPage();
            	Basket.calculate();
             }
         });     	
    },
    
    changeBasketColor: function(elem)
    {
    
        var uid = $(elem).parent().parent().attr('uid');
        var component = uid.split('^');
        newUid = component[0]  + '^' +  $(elem).val() + '^' + component[2];
     	Basket._changeUid(uid, newUid);
    },
    
    changeBasketSize: function(elem)
    {
        var uid = $(elem).parent().parent().attr('uid');
        var component = uid.split('^');
        newUid = component[0]  + '^' + component[1]   + '^' + $(elem).val();
     	Basket._changeUid(uid, newUid);
    },
    
    _changeCntSelect: function(uid)
    {
   		$('tr[' + uid + '] select.cnt option').show();
   	    var position = positions[uid];
   	    if(position == 0){
   	        $('tr[' + uid + '] select.cnt').hide();
   	        $('tr[' + uid + '] span.nocnt').show();
   	    }else{
   	        $('tr[' + uid + '] span.nocnt').hide();
   	        $('tr[' + uid + '] select.cnt').show();
   	        $('tr[' + uid + '] select.cnt option').each(
   	            function(){
   	               if(parseInt($(this).attr('cnt')) > position) $(this).hide();
   	            }
   	        );
   	    }
    },
    
    _changeUid: function(oldUid, newUid)
    {
        console.log('_changeUid');
    	$.jsHttpRequest({
             url: '/catalog/changebasketuid/',
             data: {'oldUid': oldUid, 'newUid': newUid},
             onReady: function(result, text) {
                if(text){
                    console.log(text);
                    if(confirm('   .        ?')){
                    	window.location.reload();
                    	return;
                    }
                }
             	Basket.reloadPage();
             }
         });        
    },
    
    truncate: function()
    {
		$.jsHttpRequest({
             url: '/catalog/truncatebasket/',
             onReady: function(result, text) {
		    	Basket._basket = {};
             }
         });    
    },
    
    changeColor: function(elem)
    {
       $('.color .coloritem').attr('checked', false);
       $(elem).attr('checked', true);
       Basket._checkAvailable();
    },
    
    changeSize: function(elem)
    {
       $('.clsize .sizeitem').removeClass('activesize');
       $(elem).addClass('activesize');
       Basket._checkAvailable();
    },
    
    _checkAvailable: function()
    {
    	var size     = $('.clsize .sizeitem.activesize:first').text();
    	var color    = $('.color .coloritem:checked:first').attr('color');
    	var uid = $('input[name=id]').val();
    	$('select.cnt option').show();
    	$('select.cnt').val('');
    	if(size && color){
    	    var position = positions[uid + '^' + color + '^' + size];
    	    if(position == 0){
    	        $('span.nocnt').show();
    	        $('select.cnt').hide();
    	        $('#basketButton').hide();
    	    }else{
    	        $('#basketButton').show();
    	        $('span.nocnt').hide();
    	        $('select.cnt').show();
    	        $('select.cnt option').each(
    	            function(){
    	               if(parseInt($(this).attr('cnt')) > position) $(this).hide();
    	            }
    	        );
    	    }
    	}
    },
    
    gotoOrder: function()
    {
    	if(parseFloat($('.total .cost span').text()) < minOrderSum) {
	    	  Message.show(' ', '        ' + minOrderSum + '.', 5);
	    	  return;
    	}
        $('.basket-block').slideUp('slow'); 
        $('.order-block').slideDown('slow');
        $.datepicker.setDefaults($.datepicker.regional['ru']);
        Tools.enableDatePicker(null, {dateFormat: 'dd.mm.yy', minDate: '+2d', maxDate: '+7d', beforeShowDay: $.datepicker.noWeekends});
        if($('input[name=customerId]').val()){
	        $.jsHttpRequest({
	             url: '/customer/getinfo/',
	             onReady: function(result, text) {
	                 if(!text){
	                 	Customer._initOrderForm(result);
	                 }else{
	                    console.log(text);
	                 }   
	             }
	         });          
        }
    }
}

Order = {
	checkDiscountCard: function(discountCardNumber, callback)
	{
		if(!discountCardNumber){
			 Message.show('  ', '     ', 5);
			 return;
		}
        $.jsHttpRequest({
            url: '/customer/check-discount-card/',
            data: {'discountCardNumber' : discountCardNumber },
            onReady: function(result, text) {
                if(result.isValid){
                	$('#loader').show();
                    if (typeof(callback) == 'function') {
                    	callback();
                    }
                }else{
                   Message.show('  ', '          .                .', 5);
                }
            }
        }); 		
	},
		
    activateDateTimeBlock: function(elem)
    {
    	var showCash = false;
    	$('.date-time-order').hide();
    	if(       $(elem).attr('value') == 'aa-aa-000001' 
    		   || $(elem).attr('value') == 'aa-aa-000002' 
    		   || $(elem).attr('value') == 'aa-aa-000006' 
    		   || $(elem).attr('value') == 'aa-aa-000007'){
    		$('.date-time-order').show();
    		showCash = true;
    		
    	}
    	if(showCash || $(elem).attr('value') == 'aa-aa-000003' ) {
           $('.payment-type .cash').show();  	   
           $('.payment-type .postPayment').hide();  	   
    	}else{
           $('.payment-type .cash').hide();  	   
           $('.payment-type .postPayment').show();  	   
    	}
    },
    
    add: function(elem)
    {
    	if(Basket._basket.length == 0){
    	    Message.show(' ', ' ', 5);
    	    return;
    	}
    	if(!$('textarea[name=deliveryAddress]').val()){
    	    Message.show(' ', '   ', 5);
    	    return;
    	}
    	
    	if(!$('input[name=deliveryFio]').val()){
    	    Message.show(' ', '  ', 5);
    	    return;
    	}
    	if(!$('input[name=deliveryPhone]').val()){
    	    Message.show(' ', '   ', 5);
    	    return;
    	}
    	if(!$('input[name=deliveryTypeId]:checked').length){
    	    Message.show(' ', '   ', 5);
    	    return;
    	}
    	if(!$('input[name=deliveryTypeId]:checked').val()){
    		Message.show(' ', '   ', 5);
    		return;
    	}
    	if(!$('input[name=paymentTypeId]:checked').length){
    	    Message.show(' ', '   ', 5);
    	    return;
    	}
    	var orderData = $('.order-form').serializeHash();
    	orderData['basket'] = Basket._basket;
    	$(elem).parent().parent().replaceWith('<tr><td colspan="2" style="text-align: center;"><img src="/public/images/service/ajaxloaderwhite.gif"><br /> ...</td></tr>');
        $.jsHttpRequest({
             url: '/customer/addorder/',
             data: orderData,
             onReady: function(result, text) {
                 if(!result.errorMessage){
					$('.order-form').html(text);
					Basket.truncate();
                 }else{
                    Message.show(' ', result.errorMessage, 5);
                 }
             }
         });     	
    }
}
