/**
 * 画像通報クラス
 *
 * 例
 * 通報モード切替ボタンタグ
 * <a href="javascript:void(0);" onclick="javascript:ImageReport.swapMode();"><img src="/img/btn_report.gif" border="0" alt="report"></a>
 * 画像タグ
 * <a href="http://www.example.com"><img src="http://www.example.com/xxx.png" border="0" onclick="return ImageReport.doPost(this)"></a>
 */
var ImageReportClass = function() {
    /**#@+
     * @access private
     */
    this._mode = 0;    // 通報モードON・OFF
    this._targetUrl = "http://my.teacup.com/unpleasant";        // 通報システムurl
    /**#@-*/
    
    if (document.domain.match(/^test/)) this._targetUrl = "http://my-test.teacup.com/unpleasant";    // test
}
ImageReportClass.prototype = {
    /**#@+
     * @access public
     */
    
    /**
     * 画像通報モードであればPOSTする
     */
    doPost : function(link) {
        if (this._mode == 1) {    // 通報モード
            this._execPost(link);
            return false;
        }
        return true;
    },
    /**
     * 通報モード切替
     */
    swapMode : function() {
        if (this._mode == 1) {
            this._mode = 0;
            var oDiv = document.getElementById("imageReportHeader");
            oDiv.parentNode.removeChild(oDiv);
        } else {
            this._mode = 1;
            var oDiv = document.createElement("div");
            oDiv.setAttribute("id", "imageReportHeader");
            oDiv.innerHTML = "<div class='imageReportHeader'>画像通報モードON　通報したい画像をクリックしてください。</div>";
            document.body.insertBefore(oDiv, document.body.firstChild);
        }
    },
    /**#@-*/
    
    /**#@+
     * @access private
     */
    
    /**
     * 画像通報POST実行
     */
    _execPost : function(link) {
        // まずポップアップを開く
        window.open("about:blank", "postUnpleasantPopup", "width=550,height=600").focus();
        this._appendHiddenForm();
        document.postUnpleasant.url.value = link.src;
        document.postUnpleasant.related_url.value = link.parentNode;
        document.postUnpleasant.submit();
        this._removeHiddenFrom();
        this.swapMode();    // 通報モードを切る
    },
    /**
     * post用隠しフォーム配置
     */
    _appendHiddenForm : function() {
        var oDiv = document.createElement("div");
        oDiv.setAttribute("id", "imageReportHiddenForm");
        oDiv.innerHTML = "<form action='" + this._targetUrl + "' method='post' target='postUnpleasantPopup' name='postUnpleasant' id='postUnpleasant'>"
        + "<input type='hidden' name='url' value=''>"
        + "<input type='hidden' name='related_url' value=''>"
        + "</form>";
        document.body.appendChild(oDiv);
    },
    /**
     * post用隠しフォーム削除
     */
    _removeHiddenFrom : function() {
        var oDiv = document.getElementById("imageReportHiddenForm");
        oDiv.parentNode.removeChild(oDiv);
    }
    /**#@-*/
}
// 今のところ実体は１つしか作成しないのでここで実体化
var ImageReport = new ImageReportClass();
